/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.FacadeCosmos;

import com.cosmodas.EntCosmos.VConsultorpremio;

import java.util.ArrayList;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 * @author obper
 */
@Stateless
public class VConsultorpremioFacade extends AbstractFacade<VConsultorpremio> implements VConsultorpremioFacadeLocal {

    @PersistenceContext(unitName = "wcosmodasPersistent")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public VConsultorpremioFacade() {
        super(VConsultorpremio.class);
    }

    @Override
    public VConsultorpremio findCallProPremios(String consultorCodigo, String fechaInicial, String fechaFinal, String programaCodigo) {

        List<VConsultorpremio> lsR = new ArrayList<VConsultorpremio>();
        StringBuilder sql = new StringBuilder("CALL pro_consultor_premio(?,?,?,?)");

        Query q = em.createNativeQuery(sql.toString(), VConsultorpremio.class);

        q.setParameter(1, consultorCodigo);
        q.setParameter(2, fechaInicial);
        q.setParameter(3, fechaFinal);
        q.setParameter(4, programaCodigo);
        lsR.addAll(q.getResultList());
        return lsR.get(0);
    }

    @Override
    public boolean validaExistenciaPremios(String premioCodigo, String salaCodigo) {

        boolean rs = false;
        StringBuilder sql = new StringBuilder("Select valida_existencia_premiosn(?,?)");
        Query q = em.createNativeQuery(sql.toString());
        q.setParameter(1, premioCodigo);
        q.setParameter(2, salaCodigo);

        List<Integer> dx = q.getResultList();
        rs = dx.get(0) == 1 ? true : false;

        return rs;
    }

    @Override
    public void entregaPremio(String consultorCodigo, String premioCodigo, String facturaCodigo) {
        StringBuilder sql = new StringBuilder("CALL entrega_premios(?,?,?)");
        Query q = em.createNativeQuery(sql.toString());
        q.setParameter(1, consultorCodigo);
        q.setParameter(2, premioCodigo);
        q.setParameter(3, facturaCodigo);
        q.executeUpdate();

    }

}
